<template>
  <div class="posts">
    <h1>Edit Post</h1>
    <form @submit.prevent="updatePost" enctype="multipart/form-data" class="form">
      <div>
        <input type="text" name="title" placeholder="TITLE" v-model="title">
      </div>
      <div>
        <textarea rows="15" cols="15" placeholder="DESCRIPTION" v-model="description"></textarea>
      </div>
      <div>
        <input type="text" name="author" placeholder="AUTHOR" v-model="author">
      </div>
      <div v-if="author_error != ''">
        <p class="form-error">{{ author_error }}</p>
      </div>
      <div>
        <input type="file" :name="uploadFileName" @change="handleFileUpload($event.target.files, $event.target.name)" accept=".png, .jpg, .jpeg">
      </div>
      <div id="container" v-if="image != ''">
        <a :href="image" target="_blank"><img :src="image"></a>
      </div>
      <div>
        <button class="app_post_btn" :disabled='isDisabled'>Update</button>
      </div>
      <div>
        <router-link v-bind:to="{ name : 'Posts' }">Back</router-link>
      </div>
    </form>
  </div>
</template>
<script>
import PostsService from '@/services/PostsService'
export default {
  name: 'EditPost',
  data () {
    return {
      title: '',
      description: '',
      author: '',
      image: '',
      title_error: '',
      author_error: '',
      uploadedFiles: [],
      uploadFileName: 'file',
      uploadFile: '',
      isDisabled: false
    }
  },
  mounted () {
    this.getPost()
  },
  methods: {
    handleFileUpload (fileList, fileName) {
      this.uploadedFiles = fileList
      this.uploadFile = fileName
      console.log(this.uploadedFiles)
    },
    async getPost () {
      const response = await PostsService.getPost({
        id: this.$route.params.id
      })
      this.title = response.data.title
      this.description = response.data.description
      this.author = response.data.author
      this.image = (typeof (response.data.image) !== 'undefined') ? response.data.image : ''
    },
    async updatePost () {
      if (this.title === '' || this.author === '') {
        this.title_error = (this.title === '') ? 'Please enter post title' : ''
        this.author_error = (this.author === '') ? 'Please enter post author' : ''
      } else {
        this.isDisabled = true
        let data = new FormData()
        data.append('title', this.title)
        data.append('description', this.description)
        data.append('author', this.author)
        if (this.uploadFile !== '') data.append('image', this.uploadedFiles[0], this.uploadedFiles[0].name)
        await PostsService.updatePost(this.$route.params.id, data).then(() => {
          this.$router.push({ name: 'Posts' })
        }).catch(error => {
          console.log(error)
        })
      }
    }
  }
}
</script>
<style type="text/css">
.form input,
.form textarea {
  width: 500px;
  padding: 10px;
  border: 1px solid #e0dede;
  outline: none;
  font-size: 12px;
}

.form div {
  margin: 20px;
}

.app_post_btn {
  background: #4d7ef7;
  color: #fff;
  padding: 10px 80px;
  text-transform: uppercase;
  font-size: 12px;
  font-weight: bold;
  width: 520px;
  border: none;
  cursor: pointer;
}

#container {
  width: 35%;
  display: inline-block;
}

#container img {
   width: 40%;
}

</style>
